diff --git a/base/server/src/engine/pkihelper.py b/base/server/src/engine/pkihelper.py
index e7735d8d37260d564d148842672bc31e6b42c638..df36583079cea16a0d199de3e0007bc7a1a12e12 100644
--- a/base/server/src/engine/pkihelper.py
+++ b/base/server/src/engine/pkihelper.py
@@ -1730,7 +1766,7 @@ class file:
                     gid = identity.get_gid()
                 config.pki_log.debug(log.PKIHELPER_CHOWN_3,
                                      uid, gid, name,
-                                     extra=config.PKI_INDENTATION_LEVEL_3)
+                                     extra = config.PKI_INDENTATION_LEVEL_3)
                 os.chown(name, uid, gid)
                 # Store record in installation manifest
                 record = manifest.record()
@@ -1746,15 +1782,15 @@ class file:
             elif not os.path.isfile(name):
                 config.pki_log.error(
                     log.PKI_FILE_ALREADY_EXISTS_NOT_A_FILE_1, name,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
                 if critical_failure == True:
-                    sys.exit(1)
+                    raise Exception(log.PKI_FILE_ALREADY_EXISTS_MOT_A_FILE_1 % name)
         except OSError as exc:
             if exc.errno == errno.EEXIST:
                 pass
             else:
                 config.pki_log.error(log.PKI_OSERROR_1, exc,
-                                     extra=config.PKI_INDENTATION_LEVEL_2)
+                                     extra = config.PKI_INDENTATION_LEVEL_2)
                 if critical_failure == True:
                     raise
         return
@@ -1762,19 +1798,19 @@ class file:
 
 # PKI Deployment Symbolic Link Class
 class symlink:
-    def create(self, name, link, uid=None, gid=None,
-               acls=None, allow_dangling_symlink=False, critical_failure=True):
+    def create(self, name, link, uid = None, gid = None,
+               acls = None, allow_dangling_symlink = False, critical_failure = True):
         try:
             if not os.path.exists(link):
                 if not os.path.exists(name):
                     config.pki_log.warning(
                         log.PKIHELPER_DANGLING_SYMLINK_2, link, name,
-                        extra=config.PKI_INDENTATION_LEVEL_2)
+                        extra = config.PKI_INDENTATION_LEVEL_2)
                     if not allow_dangling_symlink:
-                        sys.exit(1)
+                        raise Exception("Dangling symlink " + link + " not allowed")
                 # ln -s <name> <link>
                 config.pki_log.info(log.PKIHELPER_LINK_S_2, name, link,
-                                    extra=config.PKI_INDENTATION_LEVEL_2)
+                                    extra = config.PKI_INDENTATION_LEVEL_2)
                 os.symlink(name, link)
                 # REMINDER:  Due to POSIX compliance, 'lchmod' is NEVER
                 #            implemented on Linux systems since 'chmod'
@@ -1786,7 +1822,7 @@ class symlink:
                     gid = identity.get_gid()
                 config.pki_log.debug(log.PKIHELPER_CHOWN_H_3,
                                      uid, gid, link,
-                                     extra=config.PKI_INDENTATION_LEVEL_3)
+                                     extra = config.PKI_INDENTATION_LEVEL_3)
                 os.lchown(link, uid, gid)
                 # Store record in installation manifest
                 record = manifest.record()
@@ -1796,40 +1832,40 @@ class symlink:
                 record.group = master['pki_group']
                 record.uid = uid
                 record.gid = gid
-                record.permissions =\
+                record.permissions = \
                     config.PKI_DEPLOYMENT_DEFAULT_SYMLINK_PERMISSIONS
                 record.acls = acls
                 manifest.database.append(record)
             elif not os.path.islink(link):
                 config.pki_log.error(
                     log.PKI_SYMLINK_ALREADY_EXISTS_NOT_A_SYMLINK_1, link,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
                 if critical_failure == True:
-                    sys.exit(1)
+                    raise Exception(log.PKI_SYMLINK_ALREADY_EXISTS_NOT_A_SYMLINK_1 % link)
         except OSError as exc:
             if exc.errno == errno.EEXIST:
                 pass
             else:
                 config.pki_log.error(log.PKI_OSERROR_1, exc,
-                                     extra=config.PKI_INDENTATION_LEVEL_2)
+                                     extra = config.PKI_INDENTATION_LEVEL_2)
                 if critical_failure == True:
                     raise
         return
 
-    def modify(self, link, uid=None, gid=None,
-               acls=None, silent=False, critical_failure=True):
+    def modify(self, link, uid = None, gid = None,
+               acls = None, silent = False, critical_failure = True):
         try:
             if os.path.exists(link):
                 if not os.path.islink(link):
                     config.pki_log.error(
                         log.PKI_SYMLINK_ALREADY_EXISTS_NOT_A_SYMLINK_1,
-                        link, extra=config.PKI_INDENTATION_LEVEL_2)
+                        link, extra = config.PKI_INDENTATION_LEVEL_2)
                     if critical_failure == True:
-                        sys.exit(1)
+                        raise Exception(log.PKI_SYMLINK_ALREADY_EXISTS_NOT_A_SYMLINK_1 % link)
                 # Always re-process each link whether it needs it or not
                 if not silent:
                     config.pki_log.info(log.PKIHELPER_MODIFY_SYMLINK_1, link,
-                                        extra=config.PKI_INDENTATION_LEVEL_2)
+                                        extra = config.PKI_INDENTATION_LEVEL_2)
                 # REMINDER:  Due to POSIX compliance, 'lchmod' is NEVER
                 #            implemented on Linux systems since 'chmod'
                 #            CANNOT be run directly against symbolic links!
@@ -1841,7 +1877,7 @@ class symlink:
                 if not silent:
                     config.pki_log.debug(log.PKIHELPER_CHOWN_H_3,
                                          uid, gid, link,
-                                         extra=config.PKI_INDENTATION_LEVEL_3)
+                                         extra = config.PKI_INDENTATION_LEVEL_3)
                 os.lchown(link, uid, gid)
                 # Store record in installation manifest
                 if not silent:
@@ -1852,38 +1888,38 @@ class symlink:
                     record.group = master['pki_group']
                     record.uid = uid
                     record.gid = gid
-                    record.permissions =\
+                    record.permissions = \
                         config.PKI_DEPLOYMENT_DEFAULT_SYMLINK_PERMISSIONS
                     record.acls = acls
                     manifest.database.append(record)
             else:
                 config.pki_log.error(
                     log.PKI_SYMLINK_MISSING_OR_NOT_A_SYMLINK_1, link,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
                 if critical_failure == True:
-                    sys.exit(1)
+                    raise Exception(log.PKI_SYMLINK_MISSING_OR_NOT_A_SYMLINK_1 % link)
         except OSError as exc:
             config.pki_log.error(log.PKI_OSERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
                 raise
         return
 
-    def delete(self, link, critical_failure=True):
+    def delete(self, link, critical_failure = True):
         try:
             if not os.path.exists(link) or not os.path.islink(link):
                 # Simply issue a warning and continue
                 config.pki_log.warning(
                     log.PKI_SYMLINK_MISSING_OR_NOT_A_SYMLINK_1, link,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
             else:
                 # rm -f <link>
                 config.pki_log.info(log.PKIHELPER_RM_F_1, link,
-                                    extra=config.PKI_INDENTATION_LEVEL_2)
+                                    extra = config.PKI_INDENTATION_LEVEL_2)
                 os.remove(link)
         except OSError as exc:
             config.pki_log.error(log.PKI_OSERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
                 raise
         return
@@ -1896,29 +1932,29 @@ class symlink:
                 return True
         except OSError as exc:
             config.pki_log.error(log.PKI_OSERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             raise
 
 # PKI Deployment War File Class
 class war:
-    def explode(self, name, path, critical_failure=True):
+    def explode(self, name, path, critical_failure = True):
         try:
             if os.path.exists(name) and os.path.isfile(name):
                 if not zipfile.is_zipfile(name):
                     config.pki_log.error(
                         log.PKI_FILE_NOT_A_WAR_FILE_1,
-                        name, extra=config.PKI_INDENTATION_LEVEL_2)
+                        name, extra = config.PKI_INDENTATION_LEVEL_2)
                     if critical_failure == True:
-                        sys.exit(1)
+                        raise Exception(log.PKI_FILE_NOT_A_WAR_FILE_1 % name)
                 if not os.path.exists(path) or not os.path.isdir(path):
                     config.pki_log.error(
                         log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1,
-                        path, extra=config.PKI_INDENTATION_LEVEL_2)
+                        path, extra = config.PKI_INDENTATION_LEVEL_2)
                     if critical_failure == True:
-                        sys.exit(1)
+                        raise Exception(log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1, path)
                 # jar -xf <name> -C <path>
                 config.pki_log.info(log.PKIHELPER_JAR_XF_C_2, name, path,
-                                    extra=config.PKI_INDENTATION_LEVEL_2)
+                                    extra = config.PKI_INDENTATION_LEVEL_2)
                 # Open war file
                 war = zipfile.ZipFile(name, 'r')
                 # Extract contents of war file to path
@@ -1926,22 +1962,22 @@ class war:
             else:
                 config.pki_log.error(
                     log.PKI_FILE_MISSING_OR_NOT_A_FILE_1, name,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
                 if critical_failure == True:
-                    sys.exit(1)
+                    raise Exception(log.PKI_FILE_MISSING_OR_NOT_A_FILE_1, name)
         except OSError as exc:
             config.pki_log.error(log.PKI_OSERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
                 raise
         except zipfile.BadZipfile as exc:
             config.pki_log.error(log.PKI_BADZIPFILE_ERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
                 raise
         except zipfile.LargeZipFile as exc:
             config.pki_log.error(log.PKI_LARGEZIPFILE_ERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
                 raise
         return
@@ -1949,75 +1985,75 @@ class war:
 
 # PKI Deployment Password Class
 class password:
-    def create_password_conf(self, path, pin, pin_sans_token=False,
-                             overwrite_flag=False, critical_failure=True):
+    def create_password_conf(self, path, pin, pin_sans_token = False,
+                             overwrite_flag = False, critical_failure = True):
         try:
             if os.path.exists(path):
                 if overwrite_flag:
                     config.pki_log.info(
                         log.PKIHELPER_PASSWORD_CONF_1, path,
-                        extra=config.PKI_INDENTATION_LEVEL_2)
+                        extra = config.PKI_INDENTATION_LEVEL_2)
                     # overwrite the existing 'password.conf' file
                     with open(path, "wt") as fd:
                         if pin_sans_token == True:
                             fd.write(str(pin))
                         elif master['pki_subsystem'] in\
                            config.PKI_APACHE_SUBSYSTEMS:
-                            fd.write(master['pki_self_signed_token'] +\
+                            fd.write(master['pki_self_signed_token'] + \
                                      ":" + str(pin))
                         else:
-                            fd.write(master['pki_self_signed_token'] +\
+                            fd.write(master['pki_self_signed_token'] + \
                                      "=" + str(pin))
                     fd.closed
             else:
                 config.pki_log.info(log.PKIHELPER_PASSWORD_CONF_1, path,
-                                    extra=config.PKI_INDENTATION_LEVEL_2)
+                                    extra = config.PKI_INDENTATION_LEVEL_2)
                 # create a new 'password.conf' file
                 with open(path, "wt") as fd:
                     if pin_sans_token == True:
                         fd.write(str(pin))
                     elif master['pki_subsystem'] in\
                        config.PKI_APACHE_SUBSYSTEMS:
-                        fd.write(master['pki_self_signed_token'] +\
+                        fd.write(master['pki_self_signed_token'] + \
                                  ":" + str(pin))
                     else:
-                        fd.write(master['pki_self_signed_token'] +\
+                        fd.write(master['pki_self_signed_token'] + \
                                  "=" + str(pin))
                 fd.closed
         except OSError as exc:
             config.pki_log.error(log.PKI_OSERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
                 raise
         return
 
-    def create_client_pkcs12_password_conf(self, path, overwrite_flag=False,
-                                           critical_failure=True):
+    def create_client_pkcs12_password_conf(self, path, overwrite_flag = False,
+                                           critical_failure = True):
         try:
             if os.path.exists(path):
                 if overwrite_flag:
                     config.pki_log.info(
                         log.PKIHELPER_PASSWORD_CONF_1, path,
-                        extra=config.PKI_INDENTATION_LEVEL_2)
+                        extra = config.PKI_INDENTATION_LEVEL_2)
                     # overwrite the existing 'pkcs12_password.conf' file
                     with open(path, "wt") as fd:
                         fd.write(master['pki_client_pkcs12_password'])
                     fd.closed
             else:
                 config.pki_log.info(log.PKIHELPER_PASSWORD_CONF_1, path,
-                                    extra=config.PKI_INDENTATION_LEVEL_2)
+                                    extra = config.PKI_INDENTATION_LEVEL_2)
                 # create a new 'pkcs12_password.conf' file
                 with open(path, "wt") as fd:
                     fd.write(master['pki_client_pkcs12_password'])
                 fd.closed
         except OSError as exc:
             config.pki_log.error(log.PKI_OSERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
                 raise
         return
 
-    def get_password(self, path, token_name, critical_failure=True):
+    def get_password(self, path, token_name, critical_failure = True):
         if os.path.exists(path) and os.path.isfile(path) and\
            os.access(path, os.R_OK):
             tokens = PKIConfigParser.read_simple_configuration_file(path)
@@ -2032,9 +2068,9 @@ class password:
             # TODO prompt for this password
             config.pki_log.error(log.PKIHELPER_PASSWORD_NOT_FOUND_1,
                                  token_name,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
-                sys.exit(-1)
+                raise Exception(log.PKIHELPER_PASSWORD_NOT_FOUND_1 % token_name)
             else:
                 return
         return token_pwd
@@ -2044,8 +2080,8 @@ class password:
 class certutil:
     def create_security_databases(self, path, pki_cert_database,
                                   pki_key_database, pki_secmod_database,
-                                  password_file=None, prefix=None,
-                                  critical_failure=True):
+                                  password_file = None, prefix = None,
+                                  critical_failure = True):
         try:
             # Compose this "certutil" command
             command = "certutil" + " " + "-N"
@@ -2055,8 +2091,8 @@ class certutil:
             else:
                 config.pki_log.error(
                     log.PKIHELPER_CERTUTIL_MISSING_PATH,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_CERTUTIL_MISSING_PATH)
             if password_file != None:
                 command = command + " " + "-f" + " " + password_file
             if prefix != None:
@@ -2064,8 +2100,8 @@ class certutil:
             if not os.path.exists(path):
                 config.pki_log.error(
                     log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1, path,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1 % path)
             if os.path.exists(pki_cert_database) or\
                os.path.exists(pki_key_database) or\
                os.path.exists(pki_secmod_database):
@@ -2075,7 +2111,7 @@ class certutil:
                     pki_cert_database,
                     pki_key_database,
                     pki_secmod_database,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
             else:
                 if password_file != None:
                     if not os.path.exists(password_file) or\
@@ -2083,31 +2119,31 @@ class certutil:
                         config.pki_log.error(
                             log.PKI_FILE_MISSING_OR_NOT_A_FILE_1,
                             password_file,
-                            extra=config.PKI_INDENTATION_LEVEL_2)
-                        sys.exit(1)
+                            extra = config.PKI_INDENTATION_LEVEL_2)
+                        raise Exception(log.PKI_FILE_MISSING_OR_NOT_A_FILE_1 % password_file)
                 # Display this "certutil" command
                 config.pki_log.info(
                     log.PKIHELPER_CREATE_SECURITY_DATABASES_1,
                     command,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
                 # Execute this "certutil" command
-                subprocess.call(command, shell=True)
+                subprocess.call(command, shell = True)
         except subprocess.CalledProcessError as exc:
             config.pki_log.error(log.PKI_SUBPROCESS_ERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
                 raise
         except OSError as exc:
             config.pki_log.error(log.PKI_OSERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
                 raise
         return
 
     def verify_certificate_exists(self, path, pki_cert_database,
                                   pki_key_database, pki_secmod_database,
-                                  token, nickname, password_file=None,
-                                  silent=True):
+                                  token, nickname, password_file = None,
+                                  silent = True):
         rv = 0
         try:
             # Compose this "certutil" command
@@ -2118,24 +2154,24 @@ class certutil:
             else:
                 config.pki_log.error(
                     log.PKIHELPER_CERTUTIL_MISSING_PATH,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_CERTUTIL_MISSING_PATH)
             #   Specify the 'token'
             if token:
                 command = command + " " + "-h" + " " + "'" + token + "'"
             else:
                 config.pki_log.error(
                     log.PKIHELPER_CERTUTIL_MISSING_TOKEN,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_CERTUTIL_MISSING_TOKEN)
             #   Specify the nickname of this self-signed certificate
             if nickname:
                 command = command + " " + "-n" + " " + "'" + nickname + "'"
             else:
                 config.pki_log.error(
                     log.PKIHELPER_CERTUTIL_MISSING_NICKNAME,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_CERTUTIL_MISSING_NICKNAME)
             #   OPTIONALLY specify a password file
             if password_file != None:
                 command = command + " " + "-f" + " " + password_file
@@ -2145,8 +2181,8 @@ class certutil:
             if not os.path.exists(path):
                 config.pki_log.error(
                     log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1, path,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1 % path)
             if not os.path.exists(pki_cert_database) or\
                not os.path.exists(pki_key_database) or\
                not os.path.exists(pki_secmod_database):
@@ -2156,23 +2192,24 @@ class certutil:
                     pki_cert_database,
                     pki_key_database,
                     pki_secmod_database,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKI_SECURITY_DATABASES_DO_NOT_EXIST_3 % (pki_cert_database,
+                                                                             pki_key_database, pki_secmod_database))
             if password_file != None:
                 if not os.path.exists(password_file) or\
                    not os.path.isfile(password_file):
                     config.pki_log.error(
                         log.PKI_FILE_MISSING_OR_NOT_A_FILE_1,
                         password_file,
-                        extra=config.PKI_INDENTATION_LEVEL_2)
-                    sys.exit(1)
+                        extra = config.PKI_INDENTATION_LEVEL_2)
+                    raise Exception(log.PKI_FILE_MISSING_OR_NOT_A_FILE_1 % password_file)
             # Execute this "certutil" command
-            subprocess.check_call(command, shell=True)
+            subprocess.check_call(command, shell = True)
         except subprocess.CalledProcessError as exc:
             return False
         except OSError as exc:
             config.pki_log.error(log.PKI_OSERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
                 raise
         return True
@@ -2183,8 +2220,8 @@ class certutil:
                                          subject, serial_number,
                                          validity_period, issuer_name,
                                          trustargs, noise_file,
-                                         password_file=None,
-                                         critical_failure=True):
+                                         password_file = None,
+                                         critical_failure = True):
         try:
             # Compose this "certutil" command
             command = "certutil" + " " + "-S"
@@ -2194,73 +2231,73 @@ class certutil:
             else:
                 config.pki_log.error(
                     log.PKIHELPER_CERTUTIL_MISSING_PATH,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_CERTUTIL_MISSING_PATH)
             #   Specify the 'token'
             if token:
                 command = command + " " + "-h" + " " + "'" + token + "'"
             else:
                 config.pki_log.error(
                     log.PKIHELPER_CERTUTIL_MISSING_TOKEN,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_CERTUTIL_MISSING_TOKEN)
             #   Specify the nickname of this self-signed certificate
             if nickname:
                 command = command + " " + "-n" + " " + "'" + nickname + "'"
             else:
                 config.pki_log.error(
                     log.PKIHELPER_CERTUTIL_MISSING_NICKNAME,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_CERTUTIL_MISSING_NICKNAME)
             #   Specify the subject name (RFC1485)
             if subject:
                 command = command + " " + "-s" + " " + "'" + subject + "'"
             else:
                 config.pki_log.error(
                     log.PKIHELPER_CERTUTIL_MISSING_SUBJECT,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_CERTUTIL_MISSING_SUBJECT)
             #   Specify the serial number
             if serial_number != None:
                 command = command + " " + "-m" + " " + str(serial_number)
             else:
                 config.pki_log.error(
                     log.PKIHELPER_CERTUTIL_MISSING_SERIAL_NUMBER,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_CERTUTIL_MISSING_SERIAL_NUMBER)
             #   Specify the months valid
             if validity_period != None:
                 command = command + " " + "-v" + " " + str(validity_period)
             else:
                 config.pki_log.error(
                     log.PKIHELPER_CERTUTIL_MISSING_VALIDITY_PERIOD,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_CERTUTIL_MISSING_VALIDITY_PERIOD)
             #   Specify the nickname of the issuer certificate
             if issuer_name:
-                command = command + " " + "-c" + " " +\
+                command = command + " " + "-c" + " " + \
                       "'" + issuer_name + "'"
             else:
                 config.pki_log.error(
                     log.PKIHELPER_CERTUTIL_MISSING_ISSUER_NAME,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_CERTUTIL_MISSING_ISSUER_NAME)
             #   Specify the certificate trust attributes
             if trustargs:
                 command = command + " " + "-t" + " " + "'" + trustargs + "'"
             else:
                 config.pki_log.error(
                     log.PKIHELPER_CERTUTIL_MISSING_TRUSTARGS,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_CERTUTIL_MISSING_TRUSTARGS)
             #   Specify a noise file to be used for key generation
             if noise_file:
                 command = command + " " + "-z" + " " + noise_file
             else:
                 config.pki_log.error(
                     log.PKIHELPER_CERTUTIL_MISSING_NOISE_FILE,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_CERTUTIL_MISSING_NOISE_FILE)
             #   OPTIONALLY specify a password file
             if password_file != None:
                 command = command + " " + "-f" + " " + password_file
@@ -2271,12 +2308,12 @@ class certutil:
             # Display this "certutil" command
             config.pki_log.info(
                 log.PKIHELPER_CERTUTIL_SELF_SIGNED_CERTIFICATE_1, command,
-                extra=config.PKI_INDENTATION_LEVEL_2)
+                extra = config.PKI_INDENTATION_LEVEL_2)
             if not os.path.exists(path):
                 config.pki_log.error(
                     log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1, path,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1 % path)
             if not os.path.exists(pki_cert_database) or\
                not os.path.exists(pki_key_database) or\
                not os.path.exists(pki_secmod_database):
